function varargout = opt2dui(varargin)
% OPT2DUI Application M-file for opt2dui.fig
%    FIG = OPT2DUI launch opt2dui GUI.
%    OPT2DUI('callback_name', ...) invoke the named callback.

% Last Modified by GUIDE v2.0 11-Dec-2001 11:53:43
%Setting up defaults incase user does not input anything
    
if nargin == 0  % LAUNCH GUI

	fig = openfig(mfilename,'reuse');

	% Use system color scheme for figure:
	set(fig,'Color',get(0,'defaultUicontrolBackgroundColor'));

	% Generate a structure of handles to pass to callbacks, and store it. 
	handles = guihandles(fig);
	guidata(fig, handles);
    
    %Setting up defaults incase user does not input anything
    global xlower;
    global xupper;
    global yupper;
    global ylower;
    global ftbm;
    global f;
    global minimum;
    global ftbm;
    xlower=-1.1;
    xupper=1.1;
    ylower=-1.1;
    yupper=1.1;
    ftbm='(x.^4-x.^2)+(y.^4-y.^2)';
    f=inline(ftbm);
    %minimum=[0.707 0.707 -0.5];
    %End defaults
    
	if nargout > 0
		varargout{1} = fig;
	end

elseif ischar(varargin{1}) % INVOKE NAMED SUBFUNCTION OR CALLBACK

	try
		if (nargout)
			[varargout{1:nargout}] = feval(varargin{:}); % FEVAL switchyard
		else
			feval(varargin{:}); % FEVAL switchyard
		end
	catch
		disp(lasterr);
	end

end


%| ABOUT CALLBACKS:
%| GUIDE automatically appends subfunction prototypes to this file, and 
%| sets objects' callback properties to call them through the FEVAL 
%| switchyard above. This comment describes that mechanism.
%|
%| Each callback subfunction declaration has the following form:
%| <SUBFUNCTION_NAME>(H, EVENTDATA, HANDLES, VARARGIN)
%|
%| The subfunction name is composed using the object's Tag and the 
%| callback type separated by '_', e.g. 'slider2_Callback',
%| 'figure1_CloseRequestFcn', 'axis1_ButtondownFcn'.
%|
%| H is the callback object's handle (obtained using GCBO).
%|
%| EVENTDATA is empty, but reserved for future use.
%|
%| HANDLES is a structure containing handles of components in GUI using
%| tags as fieldnames, e.g. handles.figure1, handles.slider2. This
%| structure is created at GUI startup using GUIHANDLES and stored in
%| the figure's application data using GUIDATA. A copy of the structure
%| is passed to each callback.  You can store additional information in
%| this structure at GUI startup, and you can change the structure
%| during callbacks.  Call guidata(h, handles) after changing your
%| copy to replace the stored original so that subsequent callbacks see
%| the updates. Type "help guihandles" and "help guidata" for more
%| information.
%|
%| VARARGIN contains any extra arguments you have passed to the
%| callback. Specify the extra arguments by editing the callback
%| property in the inspector. By default, GUIDE sets the property to:
%| <MFILENAME>('<SUBFUNCTION_NAME>', gcbo, [], guidata(gcbo))
%| Add any extra arguments after the last argument, before the final
%| closing parenthesis.


% --------------------------------------------------------------------
function varargout = xmin_Callback(h, eventdata, handles, varargin)
global xlower; global xupper; global ylower; global yupper; global ftbm; % Need to have all variables declared as global in each callback (not just at start of prog)
user_string = str2double(get(h,'string'));
if isnan(user_string)
    errordlg('You must enter a numeric value','Bad Input','modal')
end
xlower=user_string;

% --------------------------------------------------------------------
function varargout = xmax_Callback(h, eventdata, handles, varargin)
global xlower; global xupper; global ylower; global yupper; global ftbm;
user_string = str2double(get(h,'string'));
if isnan(user_string)
    errordlg('You must enter a numeric value','Bad Input','modal')
end
xupper=user_string;

% --------------------------------------------------------------------
function varargout = ymin_Callback(h, eventdata, handles, varargin)
global xlower; global xupper; global ylower; global yupper; global ftbm;
user_string = str2double(get(h,'string'));
if isnan(user_string)
    errordlg('You must enter a numeric value','Bad Input','modal')
end
ylower=user_string;

% --------------------------------------------------------------------
function varargout = ymax_Callback(h, eventdata, handles, varargin)
global xlower; global xupper; global ylower; global yupper; global ftbm;
user_string = str2double(get(h,'string'));
if isnan(user_string)
    errordlg('You must enter a numeric value','Bad Input','modal')
end
yupper=user_string;

% --------------------------------------------------------------------
function varargout = mesh_Callback(h, eventdata, handles, varargin)
global xlower; global xupper; global ylower; global yupper; global ftbm; 
f=inline(ftbm); 
[X,Y]=meshgrid(linspace(xlower,xupper,25),linspace(ylower,yupper,25));
Z=f(X+eps,Y+eps);
mesh(X,Y,Z);
simplex2;

% --------------------------------------------------------------------
function varargout = surf_Callback(h, eventdata, handles, varargin)
global xlower; global xupper; global ylower; global yupper; global ftbm; 
f=inline(ftbm); 
[X,Y]=meshgrid(linspace(xlower,xupper,25),linspace(ylower,yupper,25));
Z=f(X+eps,Y+eps);
surf(X,Y,Z);
shading interp;
simplex2;

% --------------------------------------------------------------------
function varargout = contour_Callback(h, eventdata, handles, varargin)
global xlower; global xupper; global ylower; global yupper; global ftbm; 
f=inline(ftbm); 
[X,Y]=meshgrid(linspace(xlower,xupper,25),linspace(ylower,yupper,25));
Z=f(X+eps,Y+eps);
contour(Z);
simplex2;



% --------------------------------------------------------------------
function varargout = enter_function_Callback(h, eventdata, handles, varargin)
global xlower; global xupper; global ylower; global yupper; global ftbm;
user_string = get(h,'string');
ftbm=num2str(user_string);
f=inline(ftbm);

% --------------------------------------------------------------------
function varargout = file_menu_Callback(h, eventdata, handles, varargin)

if isempty(get(handles.axes1,'Children'))
    set(handles.print_submenu,'Enable','off');
else
    set(handles.print_submenu,'Enable','on');
end




% --------------------------------------------------------------------
function varargout = print_submenu_Callback(h, eventdata, handles, varargin)

print -f handles.figure1;


% --------------------------------------------------------------------
function varargout = close_submenu_Callback(h, eventdata, handles, varargin)

delete(handles.figure1);



% --------------------------------------------------------------------
function varargout = findmin_Callback(h, eventdata, handles, varargin)
global xlower; global xupper; global ylower; global yupper; global ftbm; 
f=inline(ftbm); 
simplex2;




% --------------------------------------------------------------------
function varargout = exhaustive_Callback(h, eventdata, handles, varargin)
global xlower; global xupper; global ylower; global yupper; global ftbm; 
f=inline(ftbm); 
exhaustive;