% A program which evaluates the minimum of a function input by the user beween limits set also by user
% Enhanced Simplex algorithm

success=0; % Declare how many successful simplex moves we have done
lambda=0.3; % Setting a scaling factor, low lambda means quick scaling to centre
newpoint1(1)=(xupper+xlower)/2; %Initialising newpoint so that when we enter loop, newpoint is within restricted limits
newpoint1(2)=(yupper+ylower)/2;
intermediate=[1 1]; % again, initialising to ensure that simplex size wont be wrong in first loop
randomstart(1)=rand(1)*(xupper-xlower)/7-rand(1)*(xupper-xlower)/5;%Evaluating a randomstart selection
randomstart(2)=rand(1)*(yupper-ylower)/7-rand(1)*(yupper-ylower)/5;
donotscalepoint1=0; % A flag to see if we are at boundary - if so then set to 1 and point1 is not scaled.

% Create the simplex with 3 points to minimise 2-D unconstrained problem - using randomstart
point1=[(xupper+xlower)/2 (yupper+ylower)/2]+randomstart; % First point is initialised in middle of limits of x and y given
point2=[point1(1)+(xupper-xlower)/10 point1(2)]; % Second point is initialised in middle of limits of x and y given + delta(x) evaluated by splitting difference of xlower and xupper by 100
point3=[point1(1) point1(2)+(yupper-ylower)/10]; % Third point is initialised in middle of limits of x and y given + delta(y) evaluated by splitting difference of ylower and yupper by 100
% End creation of simplex

highx=xupper+(xupper-xlower); lowx=xlower-(xupper-xlower); highy=yupper+(yupper-ylower); lowy=ylower-(yupper-ylower); % Create an extended range so algorithm doesnt stop prematurely

while newpoint1(1)>=lowx & newpoint1(1)<=highx & newpoint1(2)>=lowy & newpoint1(2)<=highy & success<500
    
    % Evaluate simplex values at points
    value1=f(point1(1),point1(2)); % Evaluate function at point1
    value2=f(point2(1),point2(2)); % Evaluate function at point2
    value3=f(point3(1),point3(2)); % Evaluate function at point3
    % End evaluate simplex values

    % Are we at minimum?
    if abs(intermediate(1))<1e-14 & abs(intermediate(2))<1e-14
        newpoint1=(point1+point2+point3)/3;
        break
    end
    % End minimum check

    % Order points by value (value1 highest down to value3) - using bubble sort 
    if value1 < value2
        temp=point1; point1=point2; point2=temp;
        temp=value1; value1=value2; value2=temp;
    end 
    if value2 < value3
        temp=point2; point2=point3; point3=temp;
        temp=value2; value2=value3; value3=temp;
    end 
    if value1 < value2
        temp=point1; point1=point2; point2=temp;
        temp=value1; value1=value2; value2=temp;
    end
    % End bubble sort

    % Reshape simplex and increase
    midpoint=(point2+point3)/2; % Find the midpoint between point2 and point3
    intermediate=midpoint-point1; newpoint1=point1+2.1*intermediate; % Reflect point1 to become closer to minimum- extend by 10% also
    newvalue1=f(newpoint1(1),newpoint1(2)); % Evaluate value of function at this new point
    % End reshape
    
    %if newpoint is out of range set by user, then reorder points 1 and 2 so we remain in limits but still reflect to a better minimum
    if newpoint1(1)<xlower | newpoint1(1)>xupper | newpoint1(2)<ylower | newpoint1(2)>yupper 
        temp=point1; point1=point2; point2=temp;
        temp=value1; value1=value2; value2=temp;
        donotscalepoint1=1;
        % Reshape simplex with these points
        midpoint=(point2+point3)/2; % Find the midpoint between point2 and point3
        intermediate=midpoint-point1; newpoint1=point1+2*intermediate; % Reflect point1 to become closer to minimum
        newvalue1=f(newpoint1(1),newpoint1(2)); % Evaluate value of function at this new point
        if newpoint1(1)<xlower | newpoint1(1)>xupper | newpoint1(2)<ylower | newpoint1(2)>yupper % If still outwith then make the outwith value infinite.
            newvalue1=1/(0+eps);
        end
    end
    % End reshape if outwith limits
    
    success=success+1; % Increase successful iterations - used to avoid infinite loop
    
    %If we have better solution after reshape then use newpoint otherwise reduce size of simplex
    if newvalue1 < value1 
        value1=newvalue1;
        point1=newpoint1;
    else
        % If not then reduce size of Simplex using lambda declared in first line
        % Try a method of finding centre of simplex and then scaling all points toword it.
        centre=(point1+point2+point3)/3;
        intermediate1=centre-point1; intermediate2=centre-point2; intermediate3=centre-point3; % Find out the vectors from pointx to centre and name it intermediatex
        if donotscalepoint1==1
            donotscalepoint1=0;
        else
            point1=point1+(1-lambda)*intermediate1;
        end
        point2=point2+(1-lambda)*intermediate2;
        point3=point3+(1-lambda)*intermediate3;
    end
    % End of check for better solutions and resize
    
end
valueatmin=f(newpoint1(1),newpoint1(2));
global minimum;
minimum=['minimum at: (' num2str(newpoint1(1)) ',' num2str(newpoint1(2)) ')= ' num2str(valueatmin)];
title(minimum);